// Code generated by kube-linter template codegen. DO NOT EDIT.
// +build !templatecodegen

package params

import (
	"fmt"
	"strings"

	"github.com/pkg/errors"
	"golang.stackrox.io/kube-linter/pkg/check"
	"golang.stackrox.io/kube-linter/pkg/templates/util"
)

var (
	// Use some imports in case they don't get used otherwise.
	_ = util.MustParseParameterDesc
	_ = fmt.Sprintf

	forbiddenCapabilitiesParamDesc = util.MustParseParameterDesc(`{
	"Name": "forbiddenCapabilities",
	"Type": "array",
	"Description": "List of capabilities that needs to be removed from containers.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "string",
	"Required": false,
	"NoRegex": true,
	"NotNegatable": true,
	"XXXStructFieldName": "ForbiddenCapabilities",
	"XXXIsPointer": false
}
`)

	exceptionsParamDesc = util.MustParseParameterDesc(`{
	"Name": "exceptions",
	"Type": "array",
	"Description": "List of capabilities that are exceptions to the above list. This should only be filled when the above contains \"all\", and is used to forgive capabilities in ADD list.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "string",
	"Required": false,
	"NoRegex": true,
	"NotNegatable": true,
	"XXXStructFieldName": "Exceptions",
	"XXXIsPointer": false
}
`)

	ParamDescs = []check.ParameterDesc{
		forbiddenCapabilitiesParamDesc,
		exceptionsParamDesc,
	}
)

func (p *Params) Validate() error {
	var validationErrors []string
	if len(validationErrors) > 0 {
		return errors.Errorf("invalid parameters: %s", strings.Join(validationErrors, ", "))
    }
	return nil
}

// ParseAndValidate instantiates a Params object out of the passed map[string]interface{},
// validates it, and returns it.
// The return type is interface{} to satisfy the type in the Template struct.
func ParseAndValidate(m map[string]interface{}) (interface{}, error) {
	var p Params
	if err := util.DecodeMapStructure(m, &p); err != nil {
		return nil, err
	}
	if err := p.Validate(); err != nil {
		return nil, err
	}
	return p, nil
}

// WrapInstantiateFunc is a convenience wrapper that wraps an untyped instantiate function
// into a typed one.
func WrapInstantiateFunc(f func(p Params) (check.Func, error)) func (interface{}) (check.Func, error) {
	return func(paramsInt interface{}) (check.Func, error) {
		return f(paramsInt.(Params))
	}
}
