// Code generated by kube-linter template codegen. DO NOT EDIT.
// +build !templatecodegen

package params

import (
	"fmt"
	"strings"

	"github.com/pkg/errors"
	"golang.stackrox.io/kube-linter/pkg/check"
	"golang.stackrox.io/kube-linter/pkg/templates/util"
)

var (
	// Use some imports in case they don't get used otherwise.
	_ = util.MustParseParameterDesc
	_ = fmt.Sprintf

	strategyTypeRegexParamDesc = util.MustParseParameterDesc(`{
	"Name": "strategyTypeRegex",
	"Type": "string",
	"Description": "A regular expression the defines the type of update strategy allowed.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "",
	"Required": true,
	"NoRegex": false,
	"NotNegatable": false,
	"XXXStructFieldName": "StrategyTypeRegex",
	"XXXIsPointer": false
}
`)

	maxPodsUnavailableParamDesc = util.MustParseParameterDesc(`{
	"Name": "maxPodsUnavailable",
	"Type": "string",
	"Description": "The maximum value that be set in a RollingUpdate configuration for the MaxUnavailable.  This can be an integer or a percent.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "",
	"Required": false,
	"NoRegex": false,
	"NotNegatable": false,
	"XXXStructFieldName": "MaxPodsUnavailable",
	"XXXIsPointer": false
}
`)

	minPodsUnavailableParamDesc = util.MustParseParameterDesc(`{
	"Name": "minPodsUnavailable",
	"Type": "string",
	"Description": "The minimum value that be set in a RollingUpdate configuration for the MaxUnavailable.  This can be an integer or a percent.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "",
	"Required": false,
	"NoRegex": false,
	"NotNegatable": false,
	"XXXStructFieldName": "MinPodsUnavailable",
	"XXXIsPointer": false
}
`)

	maxSurgeParamDesc = util.MustParseParameterDesc(`{
	"Name": "maxSurge",
	"Type": "string",
	"Description": "The maximum value that be set in a RollingUpdate configuration for the MaxSurge.  This can be an integer or a percent.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "",
	"Required": false,
	"NoRegex": false,
	"NotNegatable": false,
	"XXXStructFieldName": "MaxSurge",
	"XXXIsPointer": false
}
`)

	minSurgeParamDesc = util.MustParseParameterDesc(`{
	"Name": "minSurge",
	"Type": "string",
	"Description": "The minimum value that be set in a RollingUpdate configuration for the MaxSurge.  This can be an integer or a percent.",
	"Examples": null,
	"Enum": null,
	"SubParameters": null,
	"ArrayElemType": "",
	"Required": false,
	"NoRegex": false,
	"NotNegatable": false,
	"XXXStructFieldName": "MinSurge",
	"XXXIsPointer": false
}
`)

	ParamDescs = []check.ParameterDesc{
		strategyTypeRegexParamDesc,
		maxPodsUnavailableParamDesc,
		minPodsUnavailableParamDesc,
		maxSurgeParamDesc,
		minSurgeParamDesc,
	}
)

func (p *Params) Validate() error {
	var validationErrors []string
	if p.StrategyTypeRegex == "" {
		validationErrors = append(validationErrors, "required param strategyTypeRegex not found")
	}
	if len(validationErrors) > 0 {
		return errors.Errorf("invalid parameters: %s", strings.Join(validationErrors, ", "))
    }
	return nil
}

// ParseAndValidate instantiates a Params object out of the passed map[string]interface{},
// validates it, and returns it.
// The return type is interface{} to satisfy the type in the Template struct.
func ParseAndValidate(m map[string]interface{}) (interface{}, error) {
	var p Params
	if err := util.DecodeMapStructure(m, &p); err != nil {
		return nil, err
	}
	if err := p.Validate(); err != nil {
		return nil, err
	}
	return p, nil
}

// WrapInstantiateFunc is a convenience wrapper that wraps an untyped instantiate function
// into a typed one.
func WrapInstantiateFunc(f func(p Params) (check.Func, error)) func (interface{}) (check.Func, error) {
	return func(paramsInt interface{}) (check.Func, error) {
		return f(paramsInt.(Params))
	}
}
